; This is a simple teletype device demonstrating the power of PCC's
; printer module. It uses variables to carry over status information.
; It simulates underlining by inserting extra lines containing "-" signs
; below the underlined characters, and "="s under bold characters.
; Those variables are used:
;   U is the extra line used for underlining
;   X is a flag set to 1 if the line contains underlined characters and
;     U must be printed
; Note that this is not the only solution for this problem, see
; UNDERLIN.CCP for an alternate solution.
; This solution doesn't use a temporary variable for printing and then
; setting it to "". The expression
;   U + (U:="")
; would cause undefined behaviour in C, but works in PCC: The expression
; in parentheses evaluates to "" and sets U to "", _after_ it has been
; used on the left side of the plus sign.

Desc            ASCII with underlining (#2)
Init            X:=0; U:=""
Done            FF
Newline         IF(X, X:=0; CR+LF+U, "")+CR+LF+(U:="")
Normal          U:=U+STRING(LEN(S)," "); S
Bold            U:=U+STRING(LEN(S),"="); X:=1; S
Underline       U:=U+STRING(LEN(S),"-"); X:=1; S
